# ilp32 build script v1.0

ROOT_PATH=`pwd`
GCC_LP64=${ROOT_PATH}/tools/gcc/lp64/gcc-linaro-6.4.1-2017.08-x86_64_aarch64-linux-gnu/bin/aarch64-linux-gnu-
GCC_ILP32=${ROOT_PATH}/tools/gcc/ilp32/gcc-linaro-7.1.1-2017.08-rc1-x86_64_aarch64-linux-gnu_ilp32/bin/aarch64-linux-gnu_ilp32-

#build linux
pushd linux
make ARCH=arm64 defconfig
make ARCH=arm64 CROSS_COMPILE=${GCC_LP64} -j4 Image dtbs
popd

#build busybox
pushd busybox
make CROSS_COMPILE=${GCC_ILP32} defconfig
sed -i 's/# CONFIG_STATIC is not set/CONFIG_STATIC=y/g' .config
make CROSS_COMPILE=${GCC_ILP32} install
popd

# build test apps 
${GCC_LP64}gcc -static -o test64 test.c
${GCC_ILP32}gcc -static -o test test.c

# package
mkdir -p ./output
cd ./output
cp ../linux/arch/arm64/boot/Image ./
cp ../busybox/busybox ./

# create filesystem
cp ../{files.txt,default.script,init.sh,test,test64} ./
../linux/usr/gen_init_cpio files.txt > ramdisk-cpio.img
../mkimage -A arm64 -C none -T ramdisk -d ./ramdisk-cpio.img -a 0x84000000 -e 0x84000000 ./ramdisk.img
